package cn.iselab.mooctest.site.web.ctrl;

import cn.iselab.mooctest.site.service.AutoReportProductService;
import cn.iselab.mooctest.site.web.data.vulData.ProjectInfoVO;
import cn.iselab.mooctest.site.web.data.vulData.VulReportDataVO;
import cn.iselab.mooctest.site.web.data.vulData.VulStatisticsVO;
import cn.iselab.mooctest.site.web.data.vulData.VulnerabilityVo;
import org.apache.commons.io.FileUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import com.google.gson.Gson;
import org.springframework.web.bind.annotation.RestController;

import java.io.File;
import java.io.IOException;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @author guochao
 * @date 2019-11-14 22:22
 */
@RestController
public class HandleReportController {

    @Value("${order.vulReport.json.upload.path}")
    private String REPORT_JSON_UPLOAD_PATH;
    @Value("${order.autoReport.upload.path}")
    private String REPORT_UPLOAD_PATH;

    @Autowired
    private AutoReportProductService autoReportProductService;

    private static final Logger log = LoggerFactory.getLogger(Process.class.getName());

    @RequestMapping(value = "/generate/report/{orderId}/{ownerId}", method = RequestMethod.GET)
    public void generateReport(@PathVariable(value = "orderId") Long orderId, @PathVariable(value = "ownerId") Long ownerId){
        List<String> menus = new ArrayList<>();
        menus.add("APK扫描");
        ProjectInfoVO projectInfoVO = new ProjectInfoVO();
        projectInfoVO.setCostTime("2019/11/15");
        projectInfoVO.setProjectName("途牛APP");
        projectInfoVO.setStartTime(new Timestamp(new Date().getTime()));
        projectInfoVO.setUserName("郭超");
        List<VulnerabilityVo> vulnerabilityVos = new ArrayList<>();
        VulStatisticsVO vulStatisticsVO = new VulStatisticsVO();

        VulReportDataVO vulReportDataVO = new VulReportDataVO();
        vulReportDataVO.setMenus(menus);
        vulReportDataVO.setProjectInfo(projectInfoVO);
        vulReportDataVO.setVulnerability(vulnerabilityVos);
        vulReportDataVO.setVulStatistics(vulStatisticsVO);
        System.out.println(vulReportDataVO.toString());
        handleReport(orderId, ownerId, vulReportDataVO);
    }


    //    @RequiresPermissions("task:create")
//    @RequestMapping(value = "generate/report", method = RequestMethod.POST)
    private void handleReport(Long orderId, Long ownerId, VulReportDataVO reportData) {
        String builderPath = autoReportProductService.copyReportBuilderToPath(orderId, "static-scan-report");
        autoReportProductService.writeDataToJsonFile(new Gson().toJson(reportData), builderPath + REPORT_JSON_UPLOAD_PATH);
        boolean bale = autoReportProductService.runBuilderToProductReport("npm run build", builderPath + "/static-scan-report/");
        if (bale) {
            reportTransferToPath(orderId, ownerId, builderPath + "/static-scan-report/");
        }
    }

    private void reportTransferToPath(Long orderId, Long ownerId, String path) {
        String autoReportPath = REPORT_UPLOAD_PATH + ownerId + "/" + orderId + "/vulReport";
        File uploadFile = new File(autoReportPath);
        boolean sign = uploadFile.mkdirs();
        log.info("------------mkdirs------------", sign);
        try {
            log.info("开始拷贝文件");
            FileUtils.copyDirectoryToDirectory(new File(path + "dist"), new File(autoReportPath));
            log.info("----------------拷贝结束-------------------");
        } catch (IOException e) {
            log.info("----------copy error{}---------", e);
        }
    }
}
